' O2common.inc
' These are the commonly use functions, equates, constants and macros
'  O2 operates in ANSI code so all constants need to be A instead of W
' Updated : Dec 30  2018

#lookahead
uses Corewin
uses Chaos

 ' Background color for main window
int  MainWindBGColor
sys hBGDC

'  Background color constants
%  BGc_Light_Yellow     = 1
%  BGc_Cyan  = 2
%  BGc_Light_Green = 3
%  BGc_Pale_Turquoise = 4
%  BGc_Mint_Cream = 5

%  BGc_Old_Lace = 6
%  BGc_HoneyDew = 7 
%  BGc_Light_Cyan  = 8
%  BGc_Papaya_Whip  = 9
%  BGc_Cornsilk  = 10

%  BGc_Azure = 11
%  BGc_Alice_Blue = 12
%  BGc_Aquamarine = 13
%  BGc_Light_Golden_Rod_Yellow = 14
%  BGc_Lavender  = 15



   '   PB message box 
 % MSGBOX    mbox

'  Variant pointer
   def varptr @ %1

 ' PB CODEPTR function
  def codeptr @ %1

'  Carriage return character
   string  cr = chr(13,10)


'  https://www.oxygenbasic.org/forum/index.php?PHPSESSID=0mb310vknpubtkphvei66447tn&topic=1816.msg19773;topicseen#msg19773
   %   istrue
   %   isfalse  not



 '  for Shellexecute 
   ! ShellExecute alias "ShellExecuteA" lib "Shell32.dll" _
                   (sys Hwnd, string operation,file,parameters,directory,sys ShowCmd) as sys



! GetTickCount lib "kernel32.dll" alias "GetTickCount" () as   sys
 ! srand lib "msvcrt.dll" (int seed)
 ! rand lib "msvcrt.dll" () as int
   

'=============================
' To seed the pseudorandom-number 
Sub Randomize()
     seed=GetTickCount
      srand GetTickCount()
End Sub 


'======================================
'  Macro for dimensioning array of zstring
' https://www.oxygenbasic.org/forum/index.php?topic=1674.0
' Reply #13
'  where  AryNam = name of Array
'  m = dimension of Array
'  n =  number of chars per array string
Macro Dim_zstring(AryNam, m,n    zz,zu)
        Type zz   char s[n]
         zz  zu[m]
         def  AryNam   zu[%1].s
End Macro







'  Font Weights 
% FW_DONTCARE   = 0
% FW_THIN       = 100
% FW_EXTRALIGHT = 200
% FW_LIGHT      = 300
% FW_NORMAL     = 400
% FW_MEDIUM     = 500
% FW_SEMIBOLD   = 600
% FW_BOLD       = 700
% FW_EXTRABOLD  = 800
%  FW_HEAVY      = 900
% LOGPIXELSY 90


% HWND_DESKTOP  0
% HWND_TOP       = 0                 ' ((HWND)0)
% HWND_BOTTOM    = 1                 ' ((HWND)1)
% HWND_TOPMOST   = &HFFFFFFFF        ' ((HWND)-1)
% HWND_NOTOPMOST = &HFFFFFFFE        ' ((HWND)-2)

' * Dialog Styles
%  DS_ABSALIGN      = &H01    
%  DS_SYSMODAL      = &H02    
%  DS_LOCALEDIT     = &H20       ' Edit items get Local storage.
%  DS_SETFONT       = &H40       ' User specified font for Dlg controls
%  DS_MODALFRAME    = &H80       ' Can be combined with WS_CAPTION
%  DS_NOIDLEMSG     = &H100      ' WM_ENTERIDLE message will not be sent
%  DS_SETFOREGROUND = &H200      ' not in win3.1
%  DS_3DLOOK        = &H0004    
%  DS_FIXEDSYS      = &H0008    
%  DS_NOFAILCREATE  = &H0010    
%  DS_CONTROL       = &H0400    
%  DS_CENTER        = &H0800    
%  DS_CENTERMOUSE   = &H1000    
%  DS_CONTEXTHELP   = &H2000    



% SS_CENTERIMAGE  = 0x200

%  WM_SIZING             = &H214
%  WM_MOVING           = &H216


'//====== Generic WM_NOTIFY notification codes
%  NM_FIRST = 0            ' generic to all controls
%  NM_LAST  = -99&

%  NM_OUTOFMEMORY     = %NM_FIRST - 1
%  NM_CLICK                   = %NM_FIRST - 2  ' uses NMCLICK type
%  NM_DBLCLK               = %NM_FIRST - 3
%  NM_RETURN            = %NM_FIRST - 4
%  NM_RCLICK              = %NM_FIRST - 5  ' uses NMCLICK type
%  NM_RDBLCLK         = %NM_FIRST - 6
%  NM_SETFOCUS        = %NM_FIRST - 7
%  NM_KILLFOCUS       = %NM_FIRST - 8

%  NM_CUSTOMDRAW      = %NM_FIRST - 12
%  NM_HOVER           = %NM_FIRST - 13


%  NM_NCHITTEST       = %NM_FIRST - 14 ' uses NMMOUSE type
%  NM_KEYDOWN         = %NM_FIRST - 15 ' uses NMKEY type
%  NM_RELEASEDCAPTURE = %NM_FIRST - 16
%  NM_SETCURSOR       = %NM_FIRST - 17 ' uses NMMOUSE type
%  NM_CHAR            = %NM_FIRST - 18 ' uses NMCHAR type


%  NM_TOOLTIPSCREATED = %NM_FIRST - 19 ' notify of when the tooltips window is create
%  NM_LDOWN           = %NM_FIRST - 20
%  NM_RDOWN           = %NM_FIRST - 21
%  NM_THEMECHANGED    = %NM_FIRST - 22


'  For the ListView header
%  HDI_TEXT             = &H0002

%  HDM_FIRST          =  &H1200
%  HDM_LAYOUT       =  HDM_FIRST + 5
%  HDM_GETITEMA    = HDM_FIRST + 3
%  HDM_GETITEMW   =  HDM_FIRST + 11
%  HDM_GETITEMRECT =  HDM_FIRST + 7


' ListView
'    following were commented out as did NOT work and are superceeded by Roland
'    %  LVCF_FMT               =      &H0001
'    %  LVCF_WIDTH             =    &H0002
'    %  LVCF_TEXT              =      &H0004
'   %  LVCF_SUBITEM         =   &H0008
 '  %  LVCF_ORDER             =     &H0020

'   by Roland
% LVCF_FMT            1
% LVCF_WIDTH        2
% LVCF_TEXT           4
% LVCF_SUBITEM     8
% LVCF_ORDER       20


%  LVCF_IMAGE             = &H0010
%  LVCF_MINWIDTH          = &H0040
%  LVCF_DEFAULTWIDTH      = &H0080
%  LVCF_IDEALWIDTH        = &H0100

%  LVIF_TEXT              =   &H00000001                       '   Roland   is  1 
%  LVIF_IMAGE             = &H00000002
%  LVIF_PARAM             = &H00000004
%  LVIF_STATE             = &H00000008
%  LVIF_INDENT            = &H00000010
%  LVIF_NORECOMPUTE       = &H00000800
%  LVIF_GROUPID           = &H00000100
%  LVIF_COLUMNS           = &H00000200

%  LVS_ICON            = &H0000 
%  LVS_REPORT          = &H0001 
%  LVS_SMALLICON       = &H0002 
%  LVS_LIST            = &H0003 
%  LVS_TYPEMASK        = &H0003 
%  LVS_SINGLESEL       = &H0004 
%  LVS_SHOWSELALWAYS   = &H0008 
%  LVS_SORTASCENDING   = &H0010 
%  LVS_SORTDESCENDING  = &H0020 
%  LVS_SHAREIMAGELISTS = &H0040 
%  LVS_NOLABELWRAP     = &H0080 
%  LVS_AUTOARRANGE     = &H0100 
%  LVS_EDITLABELS      = &H0200 

%  LVS_OWNERDATA       = &H1000 
%  LVS_NOSCROLL        = &H2000 
% LVS_TYPESTYLEMASK   = &HFC00 
%  LVS_ALIGNTOP        = &H0000 
%  LVS_ALIGNLEFT       = &H0800 
%  LVS_ALIGNMASK       = &H0C00 

%  LVS_OWNERDRAWFIXED  = &H0400 
%  LVS_NOCOLUMNHEADER  = &H4000 
%  LVS_NOSORTHEADER    = &H8000 

%  LVS_EX_GRIDLINES        = &H00000001 
%  LVS_EX_SUBITEMIMAGES    = &H00000002 
%  LVS_EX_CHECKBOXES       = &H00000004 
%  LVS_EX_TRACKSELECT      = &H00000008 
%  LVS_EX_HEADERDRAGDROP   = &H00000010 
%  LVS_EX_FULLROWSELECT    = &H00000020  ' // applies to report mode only
%  LVS_EX_ONECLICKACTIVATE = &H00000040 
%  LVS_EX_TWOCLICKACTIVATE = &H00000080 

%  LVS_EX_FLATSB           = &H00000100 
%  LVS_EX_REGIONAL         = &H00000200 
%  LVS_EX_INFOTIP          = &H00000400  ' // listview does InfoTips for you
%  LVS_EX_UNDERLINEHOT     = &H00000800 
%  LVS_EX_UNDERLINECOLD    = &H00001000 
%  LVS_EX_MULTIWORKAREAS   = &H00002000 


%  LVS_EX_LABELTIP         = &H00004000  ' // listview unfolds partly hidden labels if it does not have infotip text
%  LVS_EX_BORDERSELECT     = &H00008000  ' // border selection style instead of highlight

%  LVS_EX_DOUBLEBUFFER     = &H00010000 
%  LVS_EX_HIDELABELS       = &H00020000 
%  LVS_EX_SINGLEROW        = &H00040000 
%  LVS_EX_SNAPTOGRID       = &H00080000  ' // Icons automatically snap to grid.
%  LVS_EX_SIMPLESELECT     = &H00100000  ' // Also changes overlay rendering to top right for icon mode.

%  LVS_EX_JUSTIFYCOLUMNS   = &H00200000   ' // Icons are lined up in columns that use up the whole view area.
%  LVS_EX_TRANSPARENTBKGND = &H00400000   ' // Background is painted by the parent via WM_PRINTCLIENT
%  LVS_EX_TRANSPARENTSHADOWTEXT = &H00800000   ' // Enable shadow text on transparent backgrounds only (useful with bitmaps)
%  LVS_EX_AUTOAUTOARRANGE  = &H01000000   ' // Icons automatically arrange if no icon positions have been set
%  LVS_EX_HEADERINALLVIEWS = &H02000000   ' // Display column header in all view modes
%  LVS_EX_AUTOCHECKSELECT  = &H08000000 
%  LVS_EX_AUTOSIZECOLUMNS  = &H10000000 
%  LVS_EX_COLUMNSNAPPOINTS = &H40000000 
%  LVS_EX_COLUMNOVERFLOW   = &H80000000 


 ' ListView messages
%  LVM_FIRST              = &H1000     
%  LVM_GETITEMSTATE       = %LVM_FIRST + 44
%  LVM_SETUNICODEFORMAT   = %CCM_SETUNICODEFORMAT
%  LVM_GETUNICODEFORMAT   = %CCM_GETUNICODEFORMAT
%  LVM_GETBKCOLOR         = %LVM_FIRST + 0
%  LVM_SETBKCOLOR         = %LVM_FIRST + 1
%  LVM_GETIMAGELIST       = %LVM_FIRST + 2

%  LVM_SETIMAGELIST       = %LVM_FIRST + 3
%  LVM_GETITEMCOUNT       = %LVM_FIRST + 4

%  LVM_SETITEMA           = %LVM_FIRST + 6
%  LVM_SETITEMW           = %LVM_FIRST + 76
%  LVM_SETITEM = %LVM_SETITEMA

%  LVM_INSERTITEMA        = %LVM_FIRST + 7
%  LVM_INSERTITEMW        = %LVM_FIRST + 77
%  LVM_INSERTITEM = %LVM_INSERTITEMA

%  LVM_DELETEITEM            = %LVM_FIRST + 8
%  LVM_DELETEALLITEMS     = %LVM_FIRST + 9
%  LVM_GETCALLBACKMASK    = %LVM_FIRST + 10
%  LVM_SETCALLBACKMASK    = %LVM_FIRST + 11
%  LVM_GETNEXTITEM        = %LVM_FIRST + 12

%  LVM_FINDITEMA          = %LVM_FIRST + 13
%  LVM_FINDITEMW          = %LVM_FIRST + 83
%  LVM_FINDITEM = %LVM_FINDITEMA

%  LVM_GETITEMRECT        = %LVM_FIRST + 14
%  LVM_SETITEMPOSITION    = %LVM_FIRST + 15
%  LVM_GETITEMPOSITION    = %LVM_FIRST + 16
%  LVM_GETSTRINGWIDTHA    = %LVM_FIRST + 17
%  LVM_GETSTRINGWIDTHW    = %LVM_FIRST + 87
%  LVM_GETSTRINGWIDTH = %LVM_GETSTRINGWIDTHA

%  LVM_HITTEST            = %LVM_FIRST + 18
%  LVM_ENSUREVISIBLE      = %LVM_FIRST + 19
%  LVM_SCROLL             = %LVM_FIRST + 20
%  LVM_REDRAWITEMS        = %LVM_FIRST + 21

% LVM_ARRANGE            = %LVM_FIRST + 22
%  LVM_EDITLABELA         = %LVM_FIRST + 23
%  LVM_EDITLABELW         = %LVM_FIRST + 118
%  LVM_EDITLABEL     = %LVM_EDITLABELA

%  LVM_GETEDITCONTROL     = %LVM_FIRST + 24

%  LVM_GETCOLUMNA         = %LVM_FIRST + 25
%  LVM_GETCOLUMNW         = %LVM_FIRST + 95
%  LVM_GETCOLUMN = %LVM_GETCOLUMNA

%  LVM_SETCOLUMNA         = %LVM_FIRST + 26
%  LVM_SETCOLUMNW         = %LVM_FIRST + 96
%  LVM_SETCOLUMN = %LVM_SETCOLUMNA

%  LVM_INSERTCOLUMNA      = %LVM_FIRST + 27
%  LVM_INSERTCOLUMNW      = %LVM_FIRST + 97
%  LVM_INSERTCOLUMN = %LVM_INSERTCOLUMNA

%  LVM_DELETECOLUMN       = %LVM_FIRST + 28
%  LVM_GETCOLUMNWIDTH     = %LVM_FIRST + 29
%  LVM_SETCOLUMNWIDTH         = %LVM_FIRST + 30
%  LVM_GETHEADER          = %LVM_FIRST + 31

%  LVM_CREATEDRAGIMAGE    = %LVM_FIRST + 33
%  LVM_GETVIEWRECT        = %LVM_FIRST + 34
%  LVM_GETTEXTCOLOR       = %LVM_FIRST + 35
%  LVM_SETTEXTCOLOR       = %LVM_FIRST + 36
%  LVM_GETTEXTBKCOLOR     = %LVM_FIRST + 37
%  LVM_SETTEXTBKCOLOR     = %LVM_FIRST + 38
%  LVM_GETTOPINDEX        = %LVM_FIRST + 39
%  LVM_GETCOUNTPERPAGE    = %LVM_FIRST + 40
%  LVM_GETORIGIN          = %LVM_FIRST + 41
%  LVM_UPDATE             = %LVM_FIRST + 42
%  LVM_SETITEMSTATE       = %LVM_FIRST + 43
%  LVM_GETITEMSTATE       = %LVM_FIRST + 44

% LVM_GETITEMTEXTA       = %LVM_FIRST + 45
% LVM_GETITEMTEXTW       = %LVM_FIRST + 115
%  LVM_GETITEMTEXT     =   %LVM_GETITEMTEXTA
%  LVM_SETITEMTEXTA       = %LVM_FIRST + 46
%  LVM_SETITEMTEXTW       = %LVM_FIRST + 116
%  LVM_SETITEMTEXT      = %LVM_SETITEMTEXTA

%  LVM_SETEXTENDEDLISTVIEWSTYLE =   %LVM_FIRST + 54        '  but  Roland  is  0x1036
%  LVM_GETEXTENDEDLISTVIEWSTYLE =   %LVM_FIRST + 55


%  LVN_FIRST               = 0-100       ' listview
%  LVN_LAST                = 0-199

%  LVN_ITEMCHANGING    = %LVN_FIRST
%  LVN_ITEMCHANGED     = %LVN_FIRST - 1
%  LVN_INSERTITEM         = %LVN_FIRST - 2
%  LVN_DELETEITEM          = %LVN_FIRST - 3
%  LVN_DELETEALLITEMS  = %LVN_FIRST - 4

%  LVN_COLUMNCLICK     = %LVN_FIRST - 8
%  LVN_BEGINDRAG       = %LVN_FIRST - 9
%  LVN_BEGINRDRAG      = %LVN_FIRST - 11

%  LVSCW_AUTOSIZE             = -1
%  LVSCW_AUTOSIZE_USEHEADER   = -2


%  LVIS_FOCUSED           = &H0001 
%  LVIS_SELECTED          = &H0002 

%  LVIS_CUT               = &H0004 
%  LVIS_DROPHILITED       = &H0008 
%  LVIS_GLOW              = &H0010 
%  LVIS_ACTIVATING        = &H0020 

%  LVIS_OVERLAYMASK       = &H0F00 
%  LVIS_STATEIMAGEMASK    = &HF000 

%  CDRF_NOTIFYITEMDRAW          = &H20
%  CDRF_NOTIFYSUBITEMDRAW  = &H20
%  CDRF_SKIPDEFAULT        = &H00000004
%  CDRF_NEWFONT              = &H00000002

%  CDRF_DODEFAULT          = &H00000000
%  CDRF_DOERASE              =  &H00000004


'// drawstage flags
%  CDDS_PREPAINT           = &H00000001
%  CDDS_POSTPAINT          = &H00000002
%  CDDS_PREERASE           = &H00000003
%  CDDS_POSTERASE          = &H00000004
'// the 0x000010000 bit means it's individual item specific
%  CDDS_ITEM               = &H00010000
%  CDDS_ITEMPREPAINT       = %CDDS_ITEM OR %CDDS_PREPAINT
%  CDDS_ITEMPOSTPAINT      = %CDDS_ITEM OR %CDDS_POSTPAINT
%  CDDS_ITEMPREERASE       = %CDDS_ITEM OR %CDDS_PREERASE
%  CDDS_ITEMPOSTERASE      = %CDDS_ITEM OR %CDDS_POSTERASE
%  CDDS_SUBITEM            = &H00020000

'//   itemState flags
%  CDIS_SELECTED         = &H0001
%  CDIS_GRAYED           = &H0002   
%  CDIS_DISABLED         = &H0004   
%  CDIS_CHECKED          = &H0008   
%  CDIS_FOCUS            = &H0010   
%  CDIS_DEFAULT          = &H0020   
%  CDIS_HOT              = &H0040   
%  CDIS_MARKED           = &H0080   
%  CDIS_INDETERMINATE    = &H0100   

%  CDIS_SHOWKEYBOARDCUES = &H0200   
%  CDIS_NEARHOT          = &H0400   
%  CDIS_OTHERSIDEHOT     = &H0800   
%  CDIS_DROPHILITED      = &H1000   

' For the ListView header
%  DFC_BUTTON      = 4
%  DFCS_BUTTONPUSH       = &H0010
%  DFCS_PUSHED                = &H00000200




% LR_LOADFROMFILE=0x0010
% IMAGE_ICON=1
% STM_SETIMAGE=0x172
% SWP_NOZORDER=4 

%  COLOR_WINDOW               = 5
%  COLOR_WINDOWTEXT           = 8
% COLOR_HIGHLIGHT            = 13
% COLOR_HIGHLIGHTTEXT        = 14


' for subclassing
%  CLR_NONE = &HFFFFFFFF
%  GWLP_WNDPROC= dword -4


' Statusbar
% SB_SETPARTS 0x404
% SB_SETTEXT 0x401
% SBS_SIZEGRIP 16
% CCS_BOTTOM 3



' * Static Control Constants

%  SS_LEFT            = &H00000000 
%  SS_CENTER          = &H00000001 
%  SS_RIGHT           = &H00000002 
%  SS_ICON            = &H00000003 
%  SS_BLACKRECT       = &H00000004 
%  SS_GRAYRECT        = &H00000005 
%  SS_WHITERECT       = &H00000006 
%  SS_BLACKFRAME      = &H00000007 
%  SS_GRAYFRAME       = &H00000008 
%  SS_WHITEFRAME      = &H00000009 
%  SS_USERITEM        = &H0000000A 
%  SS_SIMPLE          = &H0000000B 
%  SS_LEFTNOWORDWRAP  = &H0000000C 

%  SS_NOWORDWRAP      = %SS_LEFTNOWORDWRAP
%  SS_OWNERDRAW       = &H0000000D 
%  SS_BITMAP          = &H0000000E 
%  SS_ENHMETAFILE     = &H0000000F 
%  SS_ETCHEDHORZ      = &H00000010 
%  SS_ETCHEDVERT      = &H00000011 
%  SS_ETCHEDFRAME     = &H00000012 
%SS_TYPEMASK        = &H0000001F 


%  SS_REALSIZECONTROL = &H00000040 

%  SS_NOPREFIX        = &H00000080   ' Don't do "&" character translation
%  SS_NOTIFY          = &H00000100 
%  SS_CENTERIMAGE     = &H00000200 
%  SS_RIGHTJUST       = &H00000400 
%  SS_REALSIZEIMAGE   = &H00000800 
%  SS_REALSIZE        = %SS_REALSIZEIMAGE
%  SS_SUNKEN          = &H00001000 
%  SS_ENDELLIPSIS     = &H00004000 
%  SS_PATHELLIPSIS    = &H00008000 
%  SS_WORDELLIPSIS    = &H0000C000 
%  SS_ELLIPSISMASK    = &H0000C000 



'  for icons
   % ICON_BIG=1
   % WM_SETICON=0x80

' Blue Colors
%    O2c_Aqua    &H00FFFF
 %   O2c_Cyan     &HFFFF00
%   O2c_Light_Cyan     &HFFFFE0
%   O2c_Dark_Cyan     &H8B8B00
 %   O2c_Pale_Turquoise     &HEEEEAF
%   O2c_Aquamarine     &HD4FF7F
%   O2c_Turquoise     &HD0E040
%   O2c_Medium_Turquoise     &HCCD148
 %   O2c_Dark_Turquoise     &HD1CE00
%   O2c_Cadet_Blue     &HA09E5F
%   O2c_Steel_Blue     &HB48246
%   O2c_Light_Steel_Blue     &HDEC4B0
%   O2c_Powder_Blue     &HE6E0B0
 %   O2c_Light_Blue     &HE6D8AD
%   O2c_Sky_Blue     &HEBCE87
%   O2c_Light_Sky_Blue     &HFACE87
%   O2c_Deep_Sky_Blue     &HFFBF00
%   O2c_Dodger_Blue     &HFF901E
%   O2c_Corn_Flower_Blue     &HED9564
%   O2c_Medium_Slate_Blue     &HEE687B
%   O2c_Royal_Blue     &HE16941
%   O2c_Blue     &HFF0000
%   O2c_Medium_Blue     &HCD0000
%   O2c_Dark_Blue      &H8B0000
 %   O2c_Navy      &H800000
 %   O2c_Midnight_Blue     &H701919

'Brown Colors
%   O2c_CornSilk    &HDCF8FF
%   O2c_Blanched_Almond     &HCDEBFF
%   O2c_Bisque    &HC4E4FF
%   O2c_Navajo_White     &HADDEFF
%   O2c_Wheat    &HB3DEF5
 %   O2c_Burly_Wood     &H87B8DE
%   O2c_Tan      &H8CB4D2
%   O2c_Rosy_Brown     &H8F8FBC
%   O2c_Sandy_Brown     &H60A4F4
 %   O2c_Golden_Rod     &H20A5DA
%   O2c_Dark_Golden_Rod     &H0B86B8
%   O2c_Peru     &H3F85CD
%   O2c_Chocolate      &H1E69D2
%   O2c_Saddle_Brown     &H13458B
%   O2c_Sienna     &H2D52A0
%   O2c_Brown     &H2A2AA5
%   O2c_Maroon     &H000080

'  Gray Colors
%   O2c_Gainsboro    &HDCDCDC
%   O2c_Light_Gray     &HD3D3D3
 %   O2c_Silver     &HC0C0C0
%   O2c_Dark_Gray     &HA9A9A9
%   O2c_Gray     &H808080
%   O2c_Dim_Gray     &H696969
%   O2c_Light_Slate_Gray     &H998877
%   O2c_Slate_Gray     &H908070
%   O2c_Dark_Slate_Gray      &H4F4F2F
%   O2c_Black     &H000000

'Green Colors
%   O2c_Green_Yellow     &H2FFFAD
%   O2c_Chartreuse     &H00FF7F
%   O2c_Lawn_Green     &H00FC7C
%   O2c_Lime     &H00FF00
%   O2c_Lime_Green     &H32CD32
%   O2c_Pale_Green     &H98FB98
%   O2c_Light_Green     &H90EE90
%   O2c_Medium_Spring_Green     &H9AFA00
%   O2c_Spring_Green     &H7FFF00
%   O2c_Medium_Sea_Green     &H71B33C
%   O2c_Sea_Green     &H578B2E
%   O2c_Forest_Green     &H228B22
%   O2c_Green     &H008000
%   O2c_Dark_Green     &H006400
%   O2c_Yellow_Green     &H32CD9A
%   O2c_Olive_Drab    &H238E6B
 %   O2c_Olive     &H008080
%   O2c_Dark_Olive_Green     &H2F6B55
 %   O2c_Medium_Aquamarine     &HAACD66
%   O2c_Dark_Sea_Green     &H8FBC8F
%   O2c_Light_Sea_Green     &HAAB220
%   O2c_Teal     &H808000
   
' Orange Colors
 %   O2c_Light_Salmon     &H7AA0FF
%   O2c_Coral     &H507FFF
 %   O2c_Tomato     &H4763FF
 %   O2c_Orange_Red     &H0045FF
 %   O2c_Dark_Orange     &H008CFF
 %   O2c_Orange     &H00A5FF
 
' Pink Colors
%   O2c_Pink     &HCBC0FF
%   O2c_Light_Pink     &HC1B6FF
%   O2c_Hot_Pink     &HB469FF
 %   O2c_Deep_Pink     &H9314FF
%   O2c_Medium_Violet_Red     &H8515C7
%   O2c_Pale_Violet_Red     &H9370DB
%   O2c_Fuschia   &HFF0080

'   Purple Colors
%   O2c_Lavender      &HFAE6E6
%   O2c_Thistle     &HD8BFD8
%   O2c_Plum     &HDDA0DD
%   O2c_Violet     &HEE82EE
%   O2c_Orchid     &HD670DA
 %   O2c_Magenta     &HFF00FF
%   O2c_Medium_Orchid     &HD355BA
%   O2c_Medium_Purple     &HDB7093
%   O2c_Blue_Violet      &HE22B8A
%   O2c_Dark_Violet     &HD30094
%   O2c_Dark_Orchid       &HCC3299
%   O2c_Dark_Magenta     &H8B008B
%   O2c_Purple     &H800080
%   O2c_Indigo     &H82004B
%   O2c_Slate_Blue     &HCD5A6A
%   O2c_Dark_Slate_Blue     &H8B3D48
%   O2c_Medium_Slate_Blue     &HEE687B
   
'  Red Colors
%   O2c_Indian_Red      &H5C5CCD
%   O2c_Light_Coral     &H8080F0
%   O2c_Salmon     &H7280FA
%   O2c_Dark_Salmon     &H7A96E9
%   O2c_Light_Salmon     &H7AA0FF
 %   O2c_Crimson      &H3C14DC
%   O2c_Red      &H0000FF
 %   O2c_Fire_Brick     &H2222B2
 %   O2c_Dark_Red     &H00008B

'  White Colors
%   O2c_White     &HFFFFFF
 %   O2c_Snow     &HFAFAFF
%   O2c_Honeydew     &HF0FFF0
%   O2c_Mint_Cream    &HFAFFF5
%   O2c_Azure             &HFFFFF0
 %   O2c_Alice_Blue     &HFFF8F0
%   O2c_GhostWhite     &HFFF8F8
%   O2c_WhiteSmoke     &HF5F5F5
 %   O2c_SeaShell    &HEEF5FF
 %   O2c_Beige      &HDCF5F5
 %   O2c_Old_Lace     &HE6F5FD
 %   O2c_Floral_White     &HF0FAFF
 %   O2c_Ivory     &HF0FFFF
 %   O2c_Antique_White     &HD7EBFA
%   O2c_Linen     &HE6F0FA
 %   O2c_Lavender_Blush     &HF5F0FF
%    O2c_Misty_Rose     &HE1E4FF

 '  Yellow Colors
%   O2c_Gold     &H00D7FF
%   O2c_Yellow     &H00FFFF
 %   O2c_Light_Yellow     &HE0FFFF
%   O2c_Lemon_Chiffon     &HCDFAFF
 %   O2c_Light_Golden_Rod_Yellow     &HD2FAFA
 %   O2c_Papaya_Whip     &HD5EFFF
%   O2c_Moccasin     &HB5E4FF
%   O2c_Peach_Puff     &HB9DAFF
%   O2c_Pale_Golden_Rod     &HAAE8EE
%   O2c_Khaki     &H8CE6F0
%   O2c_Dark_Khaki     &H6BB7BD


' DrawText  Format Flags
% DT_TOP                 = &H0
% DT_LEFT                = &H0
%  DT_CENTER              = &H00000001
%  DT_RIGHT               = &H00000002
% DT_VCENTER             = &H00000004
%  DT_BOTTOM              = &H00000008
%  DT_WORDBREAK           = &H00000010
%  DT_SINGLELINE          = &H00000020
%  DT_EXPANDTABS          = &H00000040
%  DT_TABSTOP             = &H00000080
%  DT_NOCLIP              = &H00000100
%  DT_EXTERNALLEADING     = &H00000200
% DT_CALCRECT            = &H00000400
% DT_NOPREFIX            = &H00000800
% DT_INTERNAL            = &H00001000
% DT_EDITCONTROL         = &H00002000
% DT_PATH_ELLIPSIS       = &H00004000
% DT_END_ELLIPSIS        = &H00008000
% DT_MODIFYSTRING        = &H00010000
% DT_RTLREADING          = &H00020000
% DT_WORD_ELLIPSIS       = &H00040000
% DT_NOFULLWIDTHCHARBREAK = &H00080000
% DT_HIDEPREFIX           = &H00100000
% DT_PREFIXONLY           = &H00200000

  


' Pen Styles
% PS_SOLID           = 0
% PS_DASH            = 1     ' -------
% PS_DOT             = 2     ' .......
% PS_DASHDOT         = 3     ' _._._._
% PS_DASHDOTDOT      = 4     ' _.._.._
% PS_NULL            = 5
% PS_INSIDEFRAME     = 6
% PS_USERSTYLE       = 7
% PS_ALTERNATE       = 8
% PS_STYLE_MASK      = &H0000000F
% PS_ENDCAP_ROUND    = &H00000000
% PS_ENDCAP_SQUARE   = &H00000100
% PS_ENDCAP_FLAT     = &H00000200
% PS_ENDCAP_MASK     = &H00000F00
% PS_JOIN_ROUND      = &H00000000
% PS_JOIN_BEVEL      = &H00001000
% PS_JOIN_MITER      = &H00002000
% PS_JOIN_MASK       = &H0000F000
% PS_COSMETIC        = &H00000000
% PS_GEOMETRIC       = &H00010000
%  PS_TYPE_MASK       = &H000F0000


' mouse buttons
%  WM_NCMOUSEMOVE      = &H00A0
%  WM_NCLBUTTONDOWN    = &H00A1
%  WM_NCLBUTTONUP      = &H00A2
 %  WM_NCLBUTTONDBLCLK  = &H00A3
 %  WM_NCRBUTTONDOWN    = &H00A4
%  WM_NCRBUTTONUP      = &H00A5
%  WM_NCRBUTTONDBLCLK  = &H00A6
%  WM_NCMBUTTONDOWN    = &H00A7
%  WM_NCMBUTTONUP      = &H00A8
%  WM_NCMBUTTONDBLCLK  = &H00A9

% WM_NCMOUSEHOVER = &H02A0
% WM_NCMOUSELEAVE = &H02A2



' * Key State Masks for Mouse Messages
% MK_LBUTTON  = &H0001
% MK_RBUTTON  = &H0002
% MK_SHIFT    = &H0004
% MK_CONTROL  = &H0008
% MK_MBUTTON  = &H0010
% MK_XBUTTON1 = &H0020
% MK_XBUTTON2 = &H0040



' * WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
%  HTERROR       = -2&
%  HTTRANSPARENT = -1&
%  HTNOWHERE     = 0&
%  HTCLIENT      = 1&
%  HTCAPTION     = 2&
%  HTSYSMENU     = 3&
%  HTGROWBOX     = 4&
%  HTSIZE        = %HTGROWBOX
%  HTMENU        = 5&
%  HTHSCROLL     = 6&
%  HTVSCROLL     = 7&
%  HTMINBUTTON   = 8&
%  HTMAXBUTTON   = 9&
%  HTLEFT        = 10&
%  HTRIGHT       = 11&
%  HTTOP         = 12&
%  HTTOPLEFT     = 13&
%  HTTOPRIGHT    = 14&
%  HTBOTTOM      = 15&
%  HTBOTTOMLEFT  = 16&
%  HTBOTTOMRIGHT = 17&
%  HTBORDER      = 18&
%  HTREDUCE      = %HTMINBUTTON
%  HTZOOM        = %HTMAXBUTTON
%  HTSIZEFIRST   = %HTLEFT
%  HTSIZELAST    = %HTBOTTOMRIGHT
%  HTOBJECT      = 19&
%  HTCLOSE       = 20&
%  HTHELP        = 21&


'     AnimateWindow() 
%  AW_HOR_POSITIVE = &H00000001
%  AW_HOR_NEGATIVE = &H00000002
%  AW_VER_POSITIVE = &H00000004
%  AW_VER_NEGATIVE = &H00000008
%  AW_CENTER       = &H00000010
%  AW_HIDE         = &H00010000
%  AW_ACTIVATE     = &H00020000
%  AW_SLIDE        = &H00040000
%  AW_BLEND        = &H00080000


' * Dialog Codes
%  DLGC_WANTARROWS      = &H0001&    ' Control wants arrow keys
%  DLGC_WANTTAB         = &H0002&    ' Control wants tab keys
%  DLGC_WANTALLKEYS     = &H0004&    ' Control wants all keys
%  DLGC_WANTMESSAGE     = &H0004&    ' Pass message to control
%  DLGC_HASSETSEL       = &H0008&    ' Understands EM_SETSEL message
%  DLGC_DEFPUSHBUTTON   = &H0010&    ' Default pushbutton
%  DLGC_UNDEFPUSHBUTTON = &H0020&    ' Non-default pushbutton
%  DLGC_RADIOBUTTON     = &H0040&    ' Radio button
%  DLGC_WANTCHARS       = &H0080&    ' Want WM_CHAR messages
%  DLGC_STATIC          = &H0100&    ' Static item: don't include
%  DLGC_BUTTON          = &H2000&    ' Button item: can be checked



%  WM_ENABLE               = &HA
%  WM_SETREDRAW            = &HB
%  WM_SETTEXT              = &HC
%  WM_GETTEXT              = &HD
%  WM_GETTEXTLENGTH        = &HE
%  WM_QUERYENDSESSION      = &H11
%  WM_QUERYOPEN            = &H13
%  WM_ERASEBKGND           = &H14
%  WM_SYSCOLORCHANGE       = &H15
%  WM_ENDSESSION           = &H16
%  WM_SHOWWINDOW           = &H18
%  WM_WININICHANGE         = &H1A
%  WM_SETTINGCHANGE        = %WM_WININICHANGE
%  WM_DEVMODECHANGE        = &H1B
%  WM_FONTCHANGE           = &H1D
%  WM_TIMECHANGE           = &H1E
%  WM_SETCURSOR            = &H20
%  WM_CHILDACTIVATE        = &H22
%  WM_QUEUESYNC            = &H23
%  WM_GETMINMAXINFO        = &H24
%  WM_PAINTICON            = &H26
%  WM_ICONERASEBKGND       = &H27
%  WM_NEXTDLGCTL           = &H28
%  WM_SPOOLERSTATUS        = &H2A
%  WM_MEASUREITEM          = &H2C
%  WM_DELETEITEM           = &H2D
%  WM_VKEYTOITEM           = &H2E
%  WM_CHARTOITEM           = &H2F
%  WM_SETFONT              = &H30
%  WM_GETFONT              = &H31
%  WM_SETHOTKEY            = &H32
%  WM_GETHOTKEY            = &H33
%  WM_QUERYDRAGICON        = &H37
%  WM_COMPAREITEM          = &H39
%  WM_GETOBJECT            = &H3D
%  WM_COMPACTING           = &H41


%  WM_ICONERASEBKGND       = &H0027 
%  WM_NEXTDLGCTL           = &H0028 
%  WM_SPOOLERSTATUS        = &H002A 
%  WM_DRAWITEM             = &H002B 



%  WM_CUT               = &H0300 
%  WM_COPY              = &H0301 
%  WM_PASTE             = &H0302 
%  WM_CLEAR             = &H0303 
%  WM_UNDO              = &H0304 
%  WM_RENDERFORMAT      = &H0305 
%  WM_RENDERALLFORMATS  = &H0306 
%  WM_DESTROYCLIPBOARD  = &H0307 
%  WM_DRAWCLIPBOARD     = &H0308 
%  WM_PAINTCLIPBOARD    = &H0309 
%  WM_VSCROLLCLIPBOARD  = &H030A 
%  WM_SIZECLIPBOARD     = &H030B 
%  WM_ASKCBFORMATNAME   = &H030C 
%  WM_CHANGECBCHAIN     = &H030D 
%  WM_HSCROLLCLIPBOARD  = &H030E 
%  WM_QUERYNEWPALETTE   = &H030F 
%  WM_PALETTEISCHANGING = &H0310 
%  WM_PALETTECHANGED    = &H0311 
%  WM_HOTKEY            = &H0312 

%  WM_NCCREATE         = &H0081
%  WM_NCDESTROY        = &H0082
%  WM_NCCALCSIZE       = &H0083
%  WM_NCHITTEST        = &H0084
%  WM_NCPAINT          = &H0085
%  WM_NCACTIVATE       = &H0086
%  WM_GETDLGCODE       = &H0087

%  WM_MOUSEFIRST       = &H0200
%  WM_MOUSELAST        = &H020E
%  WM_KEYLAST          =    &H0109

' Mapping Modes
%  MM_TEXT         = 1
%  MM_LOMETRIC     = 2
%  MM_HIMETRIC     = 3
%  MM_LOENGLISH    = 4
%  MM_HIENGLISH    = 5
%  MM_TWIPS        = 6
%  MM_ISOTROPIC    = 7
%  MM_ANISOTROPIC  = 8

' Stock Logical Objects
%  WHITE_BRUSH         = 0
%  LTGRAY_BRUSH        = 1
%  GRAY_BRUSH          = 2
%  DKGRAY_BRUSH        = 3
%  BLACK_BRUSH         = 4
%  NULL_BRUSH          = 5
%  HOLLOW_BRUSH        = %NULL_BRUSH
%  WHITE_PEN           = 6
%  BLACK_PEN           = 7
%  NULL_PEN            = 8
%  OEM_FIXED_FONT      = 10
%  ANSI_FIXED_FONT     = 11
%  ANSI_VAR_FONT       = 12
%  SYSTEM_FONT         = 13
%  DEVICE_DEFAULT_FONT = 14
%  DEFAULT_PALETTE     = 15
%  SYSTEM_FIXED_FONT   = 16
%  DEFAULT_GUI_FONT    = 17
%  DC_BRUSH            = 18
%  DC_PEN              = 19
%  STOCK_LAST          = 19  ' depending on Windows version, may be 16, 17 or 19


%  LOGPIXELSX      = 88    ' Logical pixels/inch in X
%  LOGPIXELSY      = 90    ' Logical pixels/inch in Y

TYPE APISIZE 
    LONG cx
   LONG cy
END TYPE

' SetWindowPos Flags
%  SWP_NOSIZE         = &H0001
%  SWP_NOMOVE         = &H0002
%  SWP_NOZORDER       = &H0004
%  SWP_NOREDRAW       = &H0008
%  SWP_NOACTIVATE     = &H0010
%  SWP_FRAMECHANGED   = &H0020  ' The frame changed: send WM_NCCALCSIZE
%  SWP_SHOWWINDOW       = &H0040
%  SWP_HIDEWINDOW        = &H0080
%  SWP_NOCOPYBITS        = &H0100
%  SWP_NOOWNERZORDER  = &H0200  ' Don't do owner Z ordering
%  SWP_NOSENDCHANGING = &H0400  ' Don't send WM_WINDOWPOSCHANGING
%  SWP_DRAWFRAME        =   SWP_FRAMECHANGED
%  SWP_NOREPOSITION    =   SWP_NOOWNERZORDER
%  SWP_DEFERERASE       = &H2000
%  SWP_ASYNCWINDOWPOS   = &H4000








%  FILEOPENORD       = 1536
%  MULTIFILEOPENORD  = 1537
%  PRINTDLGORD       = 1538
%  PRNSETUPDLGORD    = 1539
%  FINDDLGORD        = 1540
%  REPLACEDLGORD     = 1541
%  FONTDLGORD        = 1542
%  FORMATDLGORD31    = 1543
%  FORMATDLGORD30    = 1544

%  HKEY_CLASSES_ROOT      = &H80000000 
%  HKEY_CURRENT_USER      = &H80000001 
%  HKEY_LOCAL_MACHINE     = &H80000002 
%  HKEY_USERS             = &H80000003 
%  HKEY_PERFORMANCE_DATA  = &H80000004 
%  HKEY_CURRENT_CONFIG    = &H80000005 
%  HKEY_DYN_DATA          = &H80000006 
%  HKEY_DYNAMIC_DATA      = %HKEY_DYN_DATA

%  HKCR              = %HKEY_CLASSES_ROOT
%  HKCU              = %HKEY_CURRENT_USER
%  HKLM              = %HKEY_LOCAL_MACHINE
%  HKU                 = %HKEY_USERS
%  HKPD              = %HKEY_PERFORMANCE_DATA
%  HKCC              = %HKEY_CURRENT_CONFIG
%  HKDD              = %HKEY_DYN_DATA


%  REG_NONE                        = 0     ' No value type
%  REG_SZ                          = 1     ' Unicode nul terminated string
%  REG_EXPAND_SZ                   = 2     ' Unicode nul terminated string
%  REG_BINARY                      = 3     ' Free form binary
%  REG_DWORD                       = 4     ' 32-bit number
%  REG_DWORD_LITTLE_ENDIAN         = 4     ' 32-bit number (same as MACRO REG_DWORD)
%  REG_DWORD_BIG_ENDIAN            = 5     ' 32-bit number
%  REG_LINK                        = 6     ' Symbolic Link (unicode)
%  REG_MULTI_SZ                    = 7     ' Multiple Unicode strings
%  REG_RESOURCE_LIST               = 8     ' Resource list in the resource map
%  REG_FULL_RESOURCE_DESCRIPTOR    = 9     ' Resource list in the hardware description
%  REG_RESOURCE_REQUIREMENTS_LIST  = 10
%  REG_QWORD                       = 11    ' 64-bit number
%  REG_QWORD_LITTLE_ENDIAN         = 11    ' 64-bit number (same as MACRO REG_QWORD)


' The configuration registry database operation completed successfully.
%  ERROR_SUCCESS                    = 0&

%  ERROR_INVALID_FUNCTION           = 1&     ' dderror
%  ERROR_FILE_NOT_FOUND             = 2&
%  ERROR_PATH_NOT_FOUND             = 3&
%  ERROR_TOO_MANY_OPEN_FILES        = 4&
%  ERROR_ACCESS_DENIED              = 5&
%  ERROR_INVALID_HANDLE             = 6&
%  ERROR_ARENA_TRASHED              = 7&
%  ERROR_NOT_ENOUGH_MEMORY          = 8&     ' dderror
%  ERROR_INVALID_BLOCK              = 9&
%  ERROR_BAD_ENVIRONMENT            = 10&
%  ERROR_BAD_FORMAT                 = 11&
%  ERROR_INVALID_ACCESS             = 12&
%  ERROR_INVALID_DATA               = 13&
%  ERROR_OUTOFMEMORY                = 14&
%  ERROR_INVALID_DRIVE              = 15&
%  ERROR_CURRENT_DIRECTORY          = 16&
%  ERROR_NOT_SAME_DEVICE            = 17&
%  ERROR_NO_MORE_FILES              = 18&
%  ERROR_WRITE_PROTECT              = 19&
%  ERROR_BAD_UNIT                   = 20&
%  ERROR_NOT_READY                  = 21&
%  ERROR_BAD_COMMAND                = 22&
%  ERROR_CRC                        = 23&
%  ERROR_BAD_LENGTH                 = 24&
%  ERROR_SEEK                       = 25&
%  ERROR_NOT_DOS_DISK               = 26&
%  ERROR_SECTOR_NOT_FOUND           = 27&
%  ERROR_OUT_OF_PAPER               = 28&
%  ERROR_WRITE_FAULT                = 29&
%  ERROR_READ_FAULT                 = 30&
%  ERROR_GEN_FAILURE                = 31&
%  ERROR_SHARING_VIOLATION          = 32&
%  ERROR_LOCK_VIOLATION             = 33&
%  ERROR_WRONG_DISK                 = 34&
%  ERROR_SHARING_BUFFER_EXCEEDED    = 36&
%  ERROR_HANDLE_EOF                 = 38&
%  ERROR_HANDLE_DISK_FULL           = 39&
%  ERROR_NOT_SUPPORTED              = 50&
%  ERROR_REM_NOT_LIST               = 51&
%  ERROR_DUP_NAME                   = 52&
%  ERROR_BAD_NETPATH                = 53&
%  ERROR_NETWORK_BUSY               = 54&
%  ERROR_DEV_NOT_EXIST              = 55&     ' dderror
%  ERROR_TOO_MANY_CMDS              = 56&
%  ERROR_ADAP_HDW_ERR               = 57&
%  ERROR_BAD_NET_RESP               = 58&
%  ERROR_UNEXP_NET_ERR              = 59&
%  ERROR_BAD_REM_ADAP               = 60&
%  ERROR_PRINTQ_FULL                = 61&
%  ERROR_NO_SPOOL_SPACE             = 62&
%  ERROR_PRINT_CANCELLED            = 63&
%  ERROR_NETNAME_DELETED            = 64&
%  ERROR_NETWORK_ACCESS_DENIED      = 65&
%  ERROR_BAD_DEV_TYPE               = 66&
%  ERROR_BAD_NET_NAME               = 67&
%  ERROR_TOO_MANY_NAMES             = 68&
%  ERROR_TOO_MANY_SESS              = 69&
%  ERROR_SHARING_PAUSED             = 70&
%  ERROR_REQ_NOT_ACCEP              = 71&
%  ERROR_REDIR_PAUSED               = 72&
%  ERROR_FILE_EXISTS                = 80&
%  ERROR_CANNOT_MAKE                = 82&
%  ERROR_FAIL_I24                   = 83&
%  ERROR_OUT_OF_STRUCTURES          = 84&
%  ERROR_ALREADY_ASSIGNED           = 85&
%  ERROR_INVALID_PASSWORD           = 86&
%  ERROR_INVALID_PARAMETER          = 87&     ' dderror
%  ERROR_NET_WRITE_FAULT            = 88&
%  ERROR_NO_PROC_SLOTS              = 89&
%  ERROR_TOO_MANY_SEMAPHORES        = 100&
%  ERROR_EXCL_SEM_ALREADY_OWNED     = 101&
%  ERROR_SEM_IS_SET                 = 102&
%  ERROR_TOO_MANY_SEM_REQUESTS      = 103&
%  ERROR_INVALID_AT_INTERRUPT_TIME  = 104&
%  ERROR_SEM_OWNER_DIED             = 105&
%  ERROR_SEM_USER_LIMIT             = 106&
%  ERROR_DISK_CHANGE                = 107&
%  ERROR_DRIVE_LOCKED               = 108&
%  ERROR_BROKEN_PIPE                = 109&
%  ERROR_OPEN_FAILED                = 110&
%  ERROR_BUFFER_OVERFLOW            = 111&
%  ERROR_DISK_FULL                  = 112&
%  ERROR_NO_MORE_SEARCH_HANDLES     = 113&
%  ERROR_INVALID_TARGET_HANDLE      = 114&
%  ERROR_INVALID_CATEGORY           = 117&
%  ERROR_INVALID_VERIFY_SWITCH      = 118&
%  ERROR_BAD_DRIVER_LEVEL           = 119&
%  ERROR_CALL_NOT_IMPLEMENTED       = 120&
%  ERROR_SEM_TIMEOUT                = 121&
%  ERROR_INSUFFICIENT_BUFFER        = 122&     ' dderror
%  ERROR_INVALID_NAME               = 123&     ' dderror
%  ERROR_INVALID_LEVEL              = 124&
%  ERROR_NO_VOLUME_LABEL            = 125&
%  ERROR_MOD_NOT_FOUND              = 126&
%  ERROR_PROC_NOT_FOUND             = 127&
%  ERROR_WAIT_NO_CHILDREN           = 128&
%  ERROR_CHILD_NOT_COMPLETE         = 129&
%  ERROR_DIRECT_ACCESS_HANDLE       = 130&
%  ERROR_NEGATIVE_SEEK              = 131&
%  ERROR_SEEK_ON_DEVICE             = 132&
%  ERROR_IS_JOIN_TARGET             = 133&
%  ERROR_IS_JOINED                  = 134&
%  ERROR_IS_SUBSTED                 = 135&
%  ERROR_NOT_JOINED                 = 136&
%  ERROR_NOT_SUBSTED                = 137&
%  ERROR_JOIN_TO_JOIN               = 138&
%  ERROR_SUBST_TO_SUBST             = 139&
%  ERROR_JOIN_TO_SUBST              = 140&
%  ERROR_SUBST_TO_JOIN              = 141&
%  ERROR_BUSY_DRIVE                 = 142&
%  ERROR_SAME_DRIVE                 = 143&
%  ERROR_DIR_NOT_ROOT               = 144&
%  ERROR_DIR_NOT_EMPTY              = 145&
%  ERROR_IS_SUBST_PATH              = 146&
%  ERROR_IS_JOIN_PATH               = 147&
%  ERROR_PATH_BUSY                  = 148&
%  ERROR_IS_SUBST_TARGET            = 149&
%  ERROR_SYSTEM_TRACE               = 150&
%  ERROR_INVALID_EVENT_COUNT        = 151&
%  ERROR_TOO_MANY_MUXWAITERS        = 152&
%  ERROR_INVALID_LIST_FORMAT        = 153&
%  ERROR_LABEL_TOO_LONG             = 154&
%  ERROR_TOO_MANY_TCBS              = 155&
%  ERROR_SIGNAL_REFUSED             = 156&
%  ERROR_DISCARDED                  = 157&
%  ERROR_NOT_LOCKED                 = 158&
%  ERROR_BAD_THREADID_ADDR          = 159&
%  ERROR_BAD_ARGUMENTS              = 160&
%  ERROR_BAD_PATHNAME               = 161&
%  ERROR_SIGNAL_PENDING             = 162&
%  ERROR_MAX_THRDS_REACHED          = 164&
%  ERROR_LOCK_FAILED                = 167&
%  ERROR_BUSY                       = 170&
%  ERROR_CANCEL_VIOLATION           = 173&
%  ERROR_ATOMIC_LOCKS_NOT_SUPPORTED = 174&
%  ERROR_INVALID_SEGMENT_NUMBER     = 180&
%  ERROR_INVALID_ORDINAL            = 182&
%  ERROR_ALREADY_EXISTS             = 183&
%  ERROR_INVALID_FLAG_NUMBER        = 186&
%  ERROR_SEM_NOT_FOUND              = 187&
%  ERROR_INVALID_STARTING_CODESEG   = 188&
%  ERROR_INVALID_STACKSEG           = 189&
%  ERROR_INVALID_MODULETYPE         = 190&
%  ERROR_INVALID_EXE_SIGNATURE      = 191&
%  ERROR_EXE_MARKED_INVALID         = 192&
%  ERROR_BAD_EXE_FORMAT             = 193&
%  ERROR_ITERATED_DATA_EXCEEDS_64k  = 194&
%  ERROR_INVALID_MINALLOCSIZE       = 195&
%  ERROR_DYNLINK_FROM_INVALID_RING  = 196&
%  ERROR_IOPL_NOT_ENABLED           = 197&
%  ERROR_INVALID_SEGDPL             = 198&
%  ERROR_AUTODATASEG_EXCEEDS_64k    = 199&
%  ERROR_RING2SEG_MUST_BE_MOVABLE   = 200&
%  ERROR_RELOC_CHAIN_XEEDS_SEGLIM   = 201&
%  ERROR_INFLOOP_IN_RELOC_CHAIN     = 202&
%  ERROR_ENVVAR_NOT_FOUND           = 203&
%  ERROR_NO_SIGNAL_SENT             = 205&
%  ERROR_FILENAME_EXCED_RANGE       = 206&
%  ERROR_RING2_STACK_IN_USE         = 207&
%  ERROR_META_EXPANSION_TOO_LONG    = 208&
%  ERROR_INVALID_SIGNAL_NUMBER      = 209&
%  ERROR_THREAD_1_INACTIVE          = 210&
%  ERROR_LOCKED                     = 212&
%  ERROR_TOO_MANY_MODULES           = 214&
%  ERROR_NESTING_NOT_ALLOWED        = 215&
%  ERROR_EXE_MACHINE_TYPE_MISMATCH  = 216&
%  ERROR_BAD_PIPE                   = 230&
%  ERROR_PIPE_BUSY                  = 231&
%  ERROR_NO_DATA                    = 232&
%  ERROR_PIPE_NOT_CONNECTED         = 233&
%  ERROR_MORE_DATA                  = 234&     ' dderror
%  ERROR_VC_DISCONNECTED            = 240&
%  ERROR_INVALID_EA_NAME            = 254&
%  ERROR_EA_LIST_INCONSISTENT       = 255&
%  WAIT_TIMEOUT                     = 258&
%  ERROR_NO_MORE_ITEMS              = 259&
%  ERROR_CANNOT_COPY                = 266&
%  ERROR_DIRECTORY                  = 267&
%  ERROR_EAS_DIDNT_FIT              = 275&
%  ERROR_EA_FILE_CORRUPT            = 276&
%  ERROR_EA_TABLE_FULL              = 277&
%  ERROR_INVALID_EA_HANDLE          = 278&
%  ERROR_EAS_NOT_SUPPORTED          = 282&
%  ERROR_NOT_OWNER                  = 288&
%  ERROR_TOO_MANY_POSTS             = 298&
%  ERROR_PARTIAL_COPY               = 299&
%  ERROR_OPLOCK_NOT_GRANTED         = 300&
%  ERROR_INVALID_OPLOCK_PROTOCOL    = 301&
%  ERROR_MR_MID_NOT_FOUND           = 317&
%  ERROR_INVALID_ADDRESS            = 487&
%  ERROR_ARITHMETIC_OVERFLOW        = 534&
%  ERROR_PIPE_CONNECTED             = 535&
%  ERROR_PIPE_LISTENING             = 536&
%  ERROR_EA_ACCESS_DENIED           = 994&
%  ERROR_OPERATION_ABORTED          = 995&
%  ERROR_IO_INCOMPLETE              = 996&
%  ERROR_IO_PENDING                 = 997&     ' dderror
%  ERROR_NOACCESS                   = 998&
%  ERROR_SWAPERROR                  = 999&
%  ERROR_STACK_OVERFLOW             = 1001&
%  ERROR_INVALID_MESSAGE            = 1002&
%  ERROR_CAN_NOT_COMPLETE           = 1003&
%  ERROR_INVALID_FLAGS              = 1004&
%  ERROR_UNRECOGNIZED_VOLUME        = 1005&
%  ERROR_FILE_INVALID               = 1006&
%  ERROR_FULLSCREEN_MODE            = 1007&
%  ERROR_NO_TOKEN                   = 1008&
%  ERROR_BADDB                      = 1009&
%  ERROR_BADKEY                     = 1010&
%  ERROR_CANTOPEN                   = 1011&
%  ERROR_CANTREAD                   = 1012&
%  ERROR_CANTWRITE                  = 1013&
%  ERROR_REGISTRY_RECOVERED         = 1014&
%  ERROR_REGISTRY_CORRUPT           = 1015&
%  ERROR_REGISTRY_IO_FAILED         = 1016&
%  ERROR_NOT_REGISTRY_FILE          = 1017&
%  ERROR_KEY_DELETED                = 1018&
%  ERROR_NO_LOG_SPACE               = 1019&
%  ERROR_KEY_HAS_CHILDREN           = 1020&
%  ERROR_CHILD_MUST_BE_VOLATILE     = 1021&
%  ERROR_NOTIFY_ENUM_DIR            = 1022&
%  ERROR_DEPENDENT_SERVICES_RUNNING = 1051&
%  ERROR_INVALID_SERVICE_CONTROL    = 1052&
%  ERROR_SERVICE_REQUEST_TIMEOUT    = 1053&
%  ERROR_SERVICE_NO_THREAD          = 1054&
%  ERROR_SERVICE_DATABASE_LOCKED    = 1055&
%  ERROR_SERVICE_ALREADY_RUNNING    = 1056&
%  ERROR_INVALID_SERVICE_ACCOUNT    = 1057&
%  ERROR_SERVICE_DISABLED           = 1058&
%  ERROR_CIRCULAR_DEPENDENCY        = 1059&
%  ERROR_SERVICE_DOES_NOT_EXIST     = 1060&
%  ERROR_SERVICE_CANNOT_ACCEPT_CTRL = 1061&
%  ERROR_SERVICE_NOT_ACTIVE         = 1062&
%  ERROR_FAILED_SERVICE_CONTROLLER_CONNECT = 1063&
%  ERROR_EXCEPTION_IN_SERVICE       = 1064&
%  ERROR_DATABASE_DOES_NOT_EXIST    = 1065&
%  ERROR_SERVICE_SPECIFIC_ERROR     = 1066&
%  ERROR_PROCESS_ABORTED            = 1067&
%  ERROR_SERVICE_DEPENDENCY_FAIL    = 1068&
%  ERROR_SERVICE_LOGON_FAILED       = 1069&
%  ERROR_SERVICE_START_HANG         = 1070&
%  ERROR_INVALID_SERVICE_LOCK       = 1071&
%  ERROR_SERVICE_MARKED_FOR_DELETE  = 1072&
%  ERROR_SERVICE_EXISTS             = 1073&
%  ERROR_ALREADY_RUNNING_LKG        = 1074&
%  ERROR_SERVICE_DEPENDENCY_DELETED = 1075&
%  ERROR_BOOT_ALREADY_ACCEPTED      = 1076&
%  ERROR_SERVICE_NEVER_STARTED      = 1077&
%  ERROR_DUPLICATE_SERVICE_NAME     = 1078&
%  ERROR_DIFFERENT_SERVICE_ACCOUNT  = 1079&
%  ERROR_CANNOT_DETECT_DRIVER_FAILURE = 1080&
%  ERROR_CANNOT_DETECT_PROCESS_ABORT = 1081&
%  ERROR_NO_RECOVERY_PROGRAM        = 1082&
%  ERROR_SERVICE_NOT_IN_EXE         = 1083&
%  ERROR_END_OF_MEDIA               = 1100&
%  ERROR_FILEMARK_DETECTED          = 1101&
%  ERROR_BEGINNING_OF_MEDIA         = 1102&
%  ERROR_SETMARK_DETECTED           = 1103&
%  ERROR_NO_DATA_DETECTED           = 1104&
%  ERROR_PARTITION_FAILURE          = 1105&
%  ERROR_INVALID_BLOCK_LENGTH       = 1106&
%  ERROR_DEVICE_NOT_PARTITIONED     = 1107&
%  ERROR_UNABLE_TO_LOCK_MEDIA       = 1108&
%  ERROR_UNABLE_TO_UNLOAD_MEDIA     = 1109&
%  ERROR_MEDIA_CHANGED              = 1110&
%  ERROR_BUS_RESET                  = 1111&
%  ERROR_NO_MEDIA_IN_DRIVE          = 1112&
%  ERROR_NO_UNICODE_TRANSLATION     = 1113&
%  ERROR_DLL_INIT_FAILED            = 1114&
%  ERROR_SHUTDOWN_IN_PROGRESS       = 1115&
%  ERROR_NO_SHUTDOWN_IN_PROGRESS    = 1116&
%  ERROR_IO_DEVICE                  = 1117&
%  ERROR_SERIAL_NO_DEVICE           = 1118&
%  ERROR_IRQ_BUSY                   = 1119&
%  ERROR_MORE_WRITES                = 1120&
%  ERROR_COUNTER_TIMEOUT            = 1121&
%  ERROR_FLOPPY_ID_MARK_NOT_FOUND   = 1122&
%  ERROR_FLOPPY_WRONG_CYLINDER      = 1123&
%  ERROR_FLOPPY_UNKNOWN_ERROR       = 1124&
%  ERROR_FLOPPY_BAD_REGISTERS       = 1125&
%  ERROR_DISK_RECALIBRATE_FAILED    = 1126&
%  ERROR_DISK_OPERATION_FAILED      = 1127&
%  ERROR_DISK_RESET_FAILED          = 1128&
%  ERROR_EOM_OVERFLOW               = 1129&
%  ERROR_NOT_ENOUGH_SERVER_MEMORY   = 1130&
%  ERROR_POSSIBLE_DEADLOCK          = 1131&
%  ERROR_MAPPED_ALIGNMENT           = 1132&
%  ERROR_SET_POWER_STATE_VETOED     = 1140&
%  ERROR_SET_POWER_STATE_FAILED     = 1141&
%  ERROR_TOO_MANY_LINKS             = 1142&
%  ERROR_OLD_WIN_VERSION            = 1150&
%  ERROR_APP_WRONG_OS               = 1151&
%  ERROR_SINGLE_INSTANCE_APP        = 1152&
%  ERROR_RMODE_APP                  = 1153&
%  ERROR_INVALID_DLL                = 1154&
%  ERROR_NO_ASSOCIATION             = 1155&
%  ERROR_DDE_FAIL                   = 1156&
%  ERROR_DLL_NOT_FOUND              = 1157&
%  ERROR_NO_MORE_USER_HANDLES       = 1158&
%  ERROR_MESSAGE_SYNC_ONLY          = 1159&
%  ERROR_SOURCE_ELEMENT_EMPTY       = 1160&
%  ERROR_DESTINATION_ELEMENT_FULL   = 1161&
%  ERROR_ILLEGAL_ELEMENT_ADDRESS    = 1162&
%  ERROR_MAGAZINE_NOT_PRESENT       = 1163&
%  ERROR_DEVICE_REINITIALIZATION_NEEDED = 1164&     ' dderror
%  ERROR_DEVICE_REQUIRES_CLEANING   = 1165&
%  ERROR_DEVICE_DOOR_OPEN           = 1166&
%  ERROR_DEVICE_NOT_CONNECTED       = 1167&
%  ERROR_NOT_FOUND                  = 1168&
%  ERROR_NO_MATCH                   = 1169&
%  ERROR_SET_NOT_FOUND              = 1170&
%  ERROR_POINT_NOT_FOUND            = 1171&
%  ERROR_NO_TRACKING_SERVICE        = 1172&
%  ERROR_NO_VOLUME_ID               = 1173&
%  ERROR_INVALID_VLM_OPERATION      = 1174&
%  ERROR_UNABLE_TO_REMOVE_REPLACED  = 1175&
%  ERROR_UNABLE_TO_MOVE_REPLACEMENT = 1176&
%  ERROR_UNABLE_TO_MOVE_REPLACEMENT_2 = 1177&
%  ERROR_JOURNAL_DELETE_IN_PROGRESS = 1178&
%  ERROR_JOURNAL_NOT_ACTIVE         = 1179&
%  ERROR_POTENTIAL_FILE_FOUND       = 1180&
%  ERROR_JOURNAL_ENTRY_DELETED      = 1181&
%  ERROR_CANCELLED                  = 1223&
%  ERROR_USER_MAPPED_FILE           = 1224&
%  ERROR_CONNECTION_REFUSED         = 1225&
%  ERROR_GRACEFUL_DISCONNECT        = 1226&
%  ERROR_ADDRESS_ALREADY_ASSOCIATED = 1227&
%  ERROR_ADDRESS_NOT_ASSOCIATED     = 1228&
%  ERROR_CONNECTION_INVALID         = 1229&
%  ERROR_CONNECTION_ACTIVE          = 1230&
%  ERROR_NETWORK_UNREACHABLE        = 1231&
%  ERROR_HOST_UNREACHABLE           = 1232&
%  ERROR_PROTOCOL_UNREACHABLE       = 1233&
%  ERROR_PORT_UNREACHABLE           = 1234&
%  ERROR_REQUEST_ABORTED            = 1235&
%  ERROR_CONNECTION_ABORTED         = 1236&
%  ERROR_RETRY                      = 1237&
%  ERROR_CONNECTION_COUNT_LIMIT     = 1238&
%  ERROR_LOGIN_TIME_RESTRICTION     = 1239&
%  ERROR_LOGIN_WKSTA_RESTRICTION    = 1240&
%  ERROR_INCORRECT_ADDRESS          = 1241&
%  ERROR_ALREADY_REGISTERED         = 1242&
%  ERROR_SERVICE_NOT_FOUND          = 1243&
%  ERROR_NOT_AUTHENTICATED          = 1244&
%  ERROR_NOT_LOGGED_ON              = 1245&
%  ERROR_CONTINUE                   = 1246&     ' dderror
%  ERROR_ALREADY_INITIALIZED        = 1247&
%  ERROR_NO_MORE_DEVICES            = 1248&     ' dderror
%  ERROR_NO_SUCH_SITE               = 1249&
%  ERROR_DOMAIN_CONTROLLER_EXISTS   = 1250&
%  ERROR_ONLY_IF_CONNECTED          = 1251&
%  ERROR_OVERRIDE_NOCHANGES         = 1252&
%  ERROR_BAD_USER_PROFILE           = 1253&
%  ERROR_NOT_SUPPORTED_ON_SBS       = 1254&
%  ERROR_LICENSE_QUOTA_EXCEEDED     = 1395&
%  ERROR_WRONG_TARGET_NAME          = 1396&
%  ERROR_MUTUAL_AUTH_FAILED         = 1397&
%  ERROR_TIME_SKEW                  = 1398&
%  ERROR_GLOBAL_ONLY_HOOK           = 1429&
%  ERROR_NO_SYSTEM_RESOURCES        = 1450&
%  ERROR_NONPAGED_SYSTEM_RESOURCES  = 1451&
%  ERROR_PAGED_SYSTEM_RESOURCES     = 1452&
%  ERROR_WORKING_SET_QUOTA          = 1453&
%  ERROR_PAGEFILE_QUOTA             = 1454&
%  ERROR_COMMITMENT_LIMIT           = 1455&
%  ERROR_MENU_ITEM_NOT_FOUND        = 1456&
%  ERROR_INVALID_KEYBOARD_HANDLE    = 1457&
%  ERROR_HOOK_TYPE_NOT_ALLOWED      = 1458&
%  ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION = 1459&
%  ERROR_TIMEOUT                    = 1460&
%  ERROR_INVALID_MONITOR_HANDLE     = 1461&
%  ERROR_INSTALL_SERVICE_FAILURE    = 1601&
%  ERROR_INSTALL_USEREXIT           = 1602&
%  ERROR_INSTALL_FAILURE            = 1603&
%  ERROR_INSTALL_SUSPEND            = 1604&
%  ERROR_UNKNOWN_PRODUCT            = 1605&
%  ERROR_UNKNOWN_FEATURE            = 1606&
%  ERROR_UNKNOWN_COMPONENT          = 1607&
%  ERROR_UNKNOWN_PROPERTY           = 1608&
%  ERROR_INVALID_HANDLE_STATE       = 1609&
%  ERROR_BAD_CONFIGURATION          = 1610&
%  ERROR_INDEX_ABSENT               = 1611&
%  ERROR_INSTALL_SOURCE_ABSENT      = 1612&
%  ERROR_INSTALL_PACKAGE_VERSION    = 1613&
%  ERROR_PRODUCT_UNINSTALLED        = 1614&
%  ERROR_BAD_QUERY_SYNTAX           = 1615&
%  ERROR_INVALID_FIELD              = 1616&
%  ERROR_DEVICE_REMOVED             = 1617&
%  ERROR_INSTALL_ALREADY_RUNNING    = 1618&
%  ERROR_INSTALL_PACKAGE_OPEN_FAILED = 1619&
%  ERROR_INSTALL_PACKAGE_INVALID    = 1620&
%  ERROR_INSTALL_UI_FAILURE         = 1621&
%  ERROR_INSTALL_LOG_FAILURE        = 1622&
%  ERROR_INSTALL_LANGUAGE_UNSUPPORTED = 1623&
%  ERROR_INSTALL_TRANSFORM_FAILURE  = 1624&
%  ERROR_INSTALL_PACKAGE_REJECTED   = 1625&
%  ERROR_FUNCTION_NOT_CALLED        = 1626&
%  ERROR_FUNCTION_FAILED            = 1627&
%  ERROR_INVALID_TABLE              = 1628&
%  ERROR_DATATYPE_MISMATCH          = 1629&
%  ERROR_UNSUPPORTED_TYPE           = 1630&
%  ERROR_CREATE_FAILED              = 1631&
%  ERROR_INSTALL_TEMP_UNWRITABLE    = 1632&
%  ERROR_INSTALL_PLATFORM_UNSUPPORTED = 1633&
%  ERROR_INSTALL_NOTUSED            = 1634&
%  ERROR_PATCH_PACKAGE_OPEN_FAILED  = 1635&
%  ERROR_PATCH_PACKAGE_INVALID      = 1636&
%  ERROR_PATCH_PACKAGE_UNSUPPORTED  = 1637&
%  ERROR_PRODUCT_VERSION            = 1638&
%  ERROR_INVALID_COMMAND_LINE       = 1639&
%  ERROR_INSTALL_REMOTE_DISALLOWED  = 1640&
%  ERROR_SUCCESS_REBOOT_INITIATED   = 1641&
%  ERROR_PATCH_TARGET_NOT_FOUND     = 1642&

         

'//  The following are masks for the predefined standard access types
'//

% DELETE                   = &H00010000 
% READ_CONTROL             = &H00020000 
% WRITE_DAC                = &H00040000 
% WRITE_OWNER              = &H00080000 
% SYNCHRONIZE              = &H00100000 

%  STANDARD_RIGHTS_REQUIRED = &H000F0000 

%  STANDARD_RIGHTS_READ     = %READ_CONTROL
%  STANDARD_RIGHTS_WRITE    = %READ_CONTROL
%  STANDARD_RIGHTS_EXECUTE  = %READ_CONTROL

%  STANDARD_RIGHTS_ALL      = &H001F0000 

%  SPECIFIC_RIGHTS_ALL      = &H0000FFFF 


'// Registry Specific Access Rights.

%  KEY_QUERY_VALUE         = &H0001 
%  KEY_SET_VALUE           = &H0002 
%  KEY_CREATE_SUB_KEY      = &H0004 
%  KEY_ENUMERATE_SUB_KEYS  = &H0008 
%  KEY_NOTIFY              = &H0010 
%  KEY_CREATE_LINK         = &H0020 
%  KEY_WOW64_32KEY         = &H0200 
%  KEY_WOW64_64KEY         = &H0100 
%  KEY_WOW64_RES           = &H0300 

%  KEY_READ               = %STANDARD_RIGHTS_READ OR %KEY_QUERY_VALUE OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY AND (NOT %SYNCHRONIZE)
%  KEY_WRITE              = %STANDARD_RIGHTS_WRITE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY AND (NOT %SYNCHRONIZE)
%  KEY_EXECUTE            = %KEY_READ
%  KEY_ALL_ACCESS         = %STANDARD_RIGHTS_ALL OR %KEY_QUERY_VALUE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY OR %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY OR %KEY_CREATE_LINK AND (NOT %SYNCHRONIZE)


'// Open/Create Options

%  REG_OPTION_RESERVED             = &H00000000      ' Parameter is reserved
%  REG_OPTION_NON_VOLATILE         = &H00000000      ' Key is preserved when system is rebooted
%  REG_OPTION_VOLATILE             = &H00000001      ' Key is not preserved when system is rebooted
%  REG_OPTION_CREATE_LINK          = &H00000002      ' Created key is a symbolic link
%  REG_OPTION_BACKUP_RESTORE       = &H00000004      ' open for backup or restore
%  REG_OPTION_OPEN_LINK            = &H00000008      ' Open symbolic link

%  REG_LEGAL_OPTION                = %REG_OPTION_RESERVED OR %REG_OPTION_NON_VOLATILE OR %REG_OPTION_VOLATILE OR %REG_OPTION_CREATE_LINK OR %REG_OPTION_BACKUP_RESTORE OR %REG_OPTION_OPEN_LINK
%  REG_OPEN_LEGAL_OPTION           = %REG_OPTION_RESERVED OR %REG_OPTION_BACKUP_RESTORE OR %REG_OPTION_OPEN_LINK



'// Key creation/open disposition
%  REG_CREATED_NEW_KEY          = &H00000001      ' New Registry Key created
%  REG_OPENED_EXISTING_KEY      = &H00000002      ' Existing Key opened


'// hive format to be used by Reg(Nt)SaveKeyEx
%  REG_STANDARD_FORMAT    = 1
%  REG_LATEST_FORMAT      = 2
%  REG_NO_COMPRESSION     = 4

% TME_HOVER      = &H00000001 
% TME_LEAVE      = &H00000002 
% TME_NONCLIENT  = &H00000010 
% TME_QUERY      = &H40000000 
% TME_CANCEL     = &H80000000 
% HOVER_DEFAULT  = &HFFFFFFFF 

' Redrawing
%  RDW_INVALIDATE       = &H0001
%  RDW_INTERNALPAINT    = &H0002
%  RDW_ERASE            = &H0004

%  RDW_VALIDATE         = &H0008
%  RDW_NOINTERNALPAINT  = &H0010
%  RDW_NOERASE          = &H0020

%  RDW_NOCHILDREN       = &H0040
%  RDW_ALLCHILDREN      = &H0080

%  RDW_UPDATENOW        = &H0100
%  RDW_ERASENOW         = &H0200

%  RDW_FRAME            = &H0400
%  RDW_NOFRAME          = &H0800

%  LR_DEFAULTCOLOR     = &H0000
%  LR_MONOCHROME       = &H0001
%  LR_COLOR            = &H0002
%  LR_COPYRETURNORG    = &H0004
%  LR_COPYDELETEORG    = &H0008
%  LR_LOADFROMFILE     = &H0010
%  LR_LOADTRANSPARENT  = &H0020
%  LR_DEFAULTSIZE      = &H0040
%  LR_VGACOLOR         = &H0080
%  LR_LOADMAP3DCOLORS  = &H1000
%  LR_CREATEDIBSECTION = &H2000
%  LR_COPYFROMRESOURCE = &H4000
%  LR_SHARED           = &H8000


' Owner drawn actions
%  ODA_DRAWENTIRE = &H1
%  ODA_SELECT     = &H2
%  ODA_FOCUS      = &H4

' Owner drawn states
%  ODS_SELECTED   = &H1
%  ODS_GRAYED     = &H2
%  ODS_DISABLED   = &H4
%  ODS_CHECKED    = &H8
%  ODS_FOCUS      = &H10
%  ODS_DEFAULT      = &H0020
%  ODS_COMBOBOXEDIT = &H1000
%  ODS_HOTLIGHT     = &H0040
%  ODS_INACTIVE     = &H0080
%  ODS_NOACCEL      = &H0100
%  ODS_NOFOCUSRECT  = &H0200

%  MOD_ALT                 = &H00000001
%  MOD_CONTROL             = &H00000002
%  MOD_SHIFT               = &H00000004
%  MOD_WIN                 = &H00000008
%  MOD_NOREPEAT  = &H4000
%  MOD_LEFT                = &H00008000
%  MOD_RIGHT               = &H00004000
%  MOD_ON_KEYUP            = &H00000800
%  MOD_IGNORE_ALL_MODIFIER = &H00000400

' * Combo Box styles
%  CBS_SIMPLE            = &H0001 
%  CBS_DROPDOWN          = &H0002 
%  CBS_DROPDOWNLIST      = &H0003 
%  CBS_OWNERDRAWFIXED    = &H0010 
%  CBS_OWNERDRAWVARIABLE = &H0020 
%  CBS_AUTOHSCROLL       = &H0040 
%  CBS_OEMCONVERT        = &H0080 
%  CBS_SORT              = &H0100 
%  CBS_HASSTRINGS        = &H0200 
%  CBS_NOINTEGRALHEIGHT  = &H0400 
%  CBS_DISABLENOSCROLL   = &H0800 

%  CBS_UPPERCASE         = &H2000 
%  CBS_LOWERCASE         = &H4000 


 '===========================
' Place the  dialog at the topmost position
' most likely be called in the  CASE  WM_INITDIALOG section
SUB Make_TopMost(BYVAL sys hwndDlg )
   SetWindowPos hwndDlg,  HWND_TOPMOST ,0,0,0,0, SWP_NOMOVE OR  SWP_NOSIZE
END SUB                        



' for flashing
% FLASHW_STOP      = 0  
% FLASHW_CAPTION   = &H00000001  
% FLASHW_TRAY        = &H00000002  
% FLASHW_ALL         =     FLASHW_CAPTION OR  FLASHW_TRAY
% FLASHW_TIMER       = &H00000004  
% FLASHW_TIMERNOFG   =  &H0000000C  

'  For flashing 
' // Size = 20 / 24 bytes
'  note that only  handle is changed to sys
TYPE FLASHWINFO 
   cbSize    AS  uint   ' UINT
   hwnd      AS  sys    ' HWND
   dwFlags   AS  dword  ' DWORD
   uCount    AS  uint   ' UINT
   dwTimeout AS  dword  ' DWORD
END TYPE


'  for Ownerdrawn structure
'type DRAWITEMSTRUCT
 ' uint  CtlType
'  uint  CtlID
 ' uint  itemID
'  uint  itemAction
 ' uint  itemState
'  sys   hwndItem
 ' sys   hDC
'  RECT  rcItem
'  dword itemData
' end type

' // Size = 48 bytes
TYPE DRAWITEMSTRUCT 
   CtlType    AS DWORD   ' UINT
   CtlID      AS DWORD   ' UINT
   itemID     AS DWORD   ' UINT
   itemAction AS DWORD   ' UINT
   itemState  AS DWORD   ' UINT
   hwndItem   AS sys    ' HWND
   hDC        AS  sys   ' HDC
   rcItem     AS RECT    ' RECT
   itemData   AS DWORD   ' ULONG_PTR
END TYPE


' // Size = 16 / 20 bytes
'  note that only  handle is changed to sys
TYPE tagTRACKMOUSEEVENT 
   cbSize      AS uint
   dwFlags     AS dword
   hwndTrack   AS sys
   dwHoverTime AS dword
END TYPE






' // Size = 60 bytes
TYPE TEXTMETRIC   ' Must be 4 byte aligned
   tmHeight           AS LONG          ' LONG
   tmAscent           AS LONG          ' LONG
   tmDescent          AS LONG          ' LONG
   tmInternalLeading  AS LONG          ' LONG
   tmExternalLeading  AS LONG          ' LONG
   tmAveCharWidth     AS LONG          ' LONG
   tmMaxCharWidth     AS LONG          ' LONG
   tmWeight           AS LONG          ' LONG
   tmOverhang         AS LONG          ' LONG
   tmDigitizedAspectX AS LONG          ' LONG
   tmDigitizedAspectY AS LONG          ' LONG
   tmFirstChar        AS WSTRING * 1   ' WCHAR
   tmLastChar         AS WSTRING * 1   ' WCHAR
   tmDefaultChar      AS WSTRING * 1   ' WCHAR
   tmBreakChar        AS WSTRING * 1   ' WCHAR
   tmItalic           AS BYTE          ' BYTE
   tmUnderlined       AS BYTE          ' BYTE
   tmStruckOut        AS BYTE          ' BYTE
   tmPitchAndFamily   AS BYTE          ' BYTE
   tmCharSet          AS BYTE          ' BYTE
   alignment__(2)     AS BYTE         ' // To keep DWORD alignment
END TYPE


' the following codes is related to getting date and time
' https://www.oxygenbasic.org/forum/index.php?topic=810.msg6615#msg6615
Type SYSTEMTIME
     word wYear 
     word wMonth
     word wDayOfWeek
     word wDay   
     word wHour   
     word wMinute
     word wSecond
     word wMilliseconds
End Type


' For Shell Execute
%  SEE_MASK_DEFAULT           = &H00000000 
%  SEE_MASK_CLASSNAME         = &H00000001    ' // SHELLEXECUTEINFO.lpClass is valid
%  SEE_MASK_CLASSKEY          = &H00000003    ' // SHELLEXECUTEINFO.hkeyClass is valid
'// Note SEE_MASK_INVOKEIDLIST(0xC) implies SEE_MASK_IDLIST(0x04)
%  SEE_MASK_IDLIST            = &H00000004    ' // SHELLEXECUTEINFO.lpIDList is valid
%  SEE_MASK_INVOKEIDLIST      = &H0000000c    ' // enable IContextMenu based verbs
%  SEE_MASK_ICON              = &H00000010    ' // not used
%  SEE_MASK_HOTKEY            = &H00000020    ' // SHELLEXECUTEINFO.dwHotKey is valid
%  SEE_MASK_NOCLOSEPROCESS    = &H00000040    ' // SHELLEXECUTEINFO.hProcess
%  SEE_MASK_CONNECTNETDRV     = &H00000080    ' // enables re-connecting disconnected network drives
%  SEE_MASK_NOASYNC           = &H00000100    ' // block on the call until the invoke has completed, use for callers that exit after calling ShellExecuteEx()
%  SEE_MASK_FLAG_DDEWAIT      = %SEE_MASK_NOASYNC   ' // Use SEE_MASK_NOASYNC instead of SEE_MASK_FLAG_DDEWAIT as it more accuratly describes the behavior
%  SEE_MASK_DOENVSUBST        = &H00000200    ' // indicates that SHELLEXECUTEINFO.lpFile contains env vars that should be expanded
%  SEE_MASK_FLAG_NO_UI        = &H00000400    ' // disable UI including error messages
%  SEE_MASK_UNICODE           = &H00004000 
%  SEE_MASK_NO_CONSOLE        = &H00008000 
%  SEE_MASK_ASYNCOK           = &H00100000 
%  SEE_MASK_HMONITOR          = &H00200000    ' // SHELLEXECUTEINFO.hMonitor
%  SEE_MASK_NOZONECHECKS      = &H00800000 
%  SEE_MASK_NOQUERYCLASSSTORE = &H01000000 
%  SEE_MASK_WAITFORINPUTIDLE  = &H02000000 
%  SEE_MASK_FLAG_LOG_USAGE    = &H04000000 


%  INFINITE = &HFFFFFFFF    ' Infinite timeout



' // Size = 60 bytes
' https://docs.microsoft.com/en-us/windows/desktop/api/shellapi/ns-shellapi-_shellexecuteinfoa
TYPE  SHELLEXECUTEINFO 
   cbSize       AS DWORD        ' DWORD  // in, required, sizeof of this structure
   fMask        AS DWORD        ' ULONG  // in, SEE_MASK_XXX values
   hwnd         AS sys        ' HWND   // in, optional
   lpVerb       AS ASCIIZ PTR   ' LPCSTR // in, optional when unspecified the default verb is choosen
   lpFile       AS ASCIIZ PTR   ' LPCSTR // in, either this value or lpIDList must be specified
   lpParameters AS ASCIIZ PTR   ' LPCSTR // in, optional
   lpDirectory  AS ASCIIZ PTR   ' LPCSTR // in, optional
   nShow        AS LONG         ' int    // in, required
   hInstApp     AS sys        ' HINSTANCE // out when SEE_MASK_NOCLOSEPROCESS is specified
   lpIDList     AS DWORD        ' LPVOID // in, valid when SEE_MASK_IDLIST is specified, PCIDLIST_ABSOLUTE, for use with SEE_MASK_IDLIST & SEE_MASK_INVOKEIDLIST
   lpClass      AS ASCIIZ PTR   ' LPCSTR // in, valid when SEE_MASK_CLASSNAME is specified
   hkeyClass    AS DWORD        ' HKEY   // in, valid when SEE_MASK_CLASSKEY is specified
   dwHotKey     AS DWORD        ' DWORD  // in, valid when SEE_MASK_HOTKEY is specified
   hIcon    AS  sys   ' HANDLE hIcon
   hMonitor AS  sys   ' HANDLE hMonitor
   hProcess     AS sys       ' HANDLE // out, valid when SEE_MASK_NOCLOSEPROCESS specified
END TYPE



'================================================
'  Function to shell execute for as long as needed to get the
'  process completed
'  If it encounter an error  (such as application file not found or
'  illegal file due to hacking )  it will not run but return an error number.
'  It will NOT display an error message so as not to alert crackers
FUNCTION ShellExx_Proc(app as string, args as string ) AS sys
    LOCAL zFl_to_run ,  zArgs AS String
    zFl_to_run=app
    zArgs=args
 
   LOCAL si   AS ShellExecuteInfo
   sys LastError

   si.cbSize       = SIZEOF(si)
   si.fmask        =  SEE_MASK_NOCLOSEPROCESS OR SEE_MASK_FLAG_NO_UI
   si.hWnd         =  NULL   'parent window
'   Need to use Strptr instead of Varptr  as these are just strings
   si.lpFile            =   STRPTR(zFl_to_run)
   si.lpParameters = STRPTR(zArgs)
    si.nShow        =  SW_SHOWNORMAL
   si.hProcess     = 0

        '     Shell execute until the process has completed
                IF ShellExecuteEx(si) = FALSE THEN
          '          when error occurs we exit the function
         '           returns the error #  , refer below for error msg management
        '             https://forum.powerbasic.com/forum/user-to-user-discussions/powerbasic-for-windows/777303-shellexecute-how-to-set-wait-for-shell-process-to-complete?p=777353#post777353
                     LastError = GetLastError()
                     Function = LastError
                END IF
                IF si.hProcess THEN
                    CALL WaitForSingleObject( si.hProcess,  INFINITE )
                END IF

END FUNCTION








' // Size = 28 bytes
TYPE tagMSG 
   hwnd    AS sys   ' HWND
   message AS DWORD   ' UINT
   wParam  AS sys   ' WPARAM
   lParam  AS sys    ' LPARAM
   time    AS DWORD   ' DWORD
   pt      AS POINT   ' POINT
END TYPE


'===============================
SUB ClearMouseBuffers
  ' Clears all previous mouse buffers
   'call just before exit sub/function to prevent re-entry by stray input
  LOCAL Msg AS TagMsg

  WHILE PeekMessage(Msg,NULL,WM_KEYFIRST,WM_KEYLAST, PM_REMOVE  _
           OR PM_NOYIELD)
  WEND

  WHILE PeekMessage(Msg,NULL,WM_MOUSEFIRST,WM_MOUSELAST, _
        PM_REMOVE OR PM_NOYIELD)
  WEND

END SUB                      





! GetDlgItem lib "user32.dll" (sys hDlg, int nIDDlgItem) as sys
! IsDialogMessage lib "user32.dll" alias"IsDialogMessageA" (sys hDlg, sys lpMsg) as bool
! IsWindow lib "user32.dll" (sys hWnd) as bool


'  for Random numbers and strings generation
 Dim   RdNumb(1000) as Long
 DIM  RdWord(1000)  as String


'=====================================
 ' Generate some random strings and numbers arrays
SUB NRandomGen ( Long wNumofEntries )
   STRING RChars , RDig  , RdWholeDig
   Long  Ir , Jr  ,  NumChars , RdWordSize
   
   If wNumofEntries > 1000 then
  '    Must NOT exceed 1000 entries
       wNumofEntries =  1000
   End if
    
   ' Selection of characters
    NumChars = 73
    RChars = "ABCDEFGHIJK=LMNOPQRSTUVWX)YZ0123456789 abcdefghijklmnopqr stuvwxyz-+$#@!"
   
   ' digits selection
    RDig = "0123456789"
    RdWordSize = 90

    FOR Ir = 1 TO wNumofEntries
            RdWord(Ir) = ""
           RdWholeDig = ""
 
         FOR Jr = 1 TO RdWordSize
             RdWord(Ir) = RdWord(Ir) +    MID(RChars, irnd(1,NumChars) + 1, 1)
             RdWholeDig = RdWholeDig +   MID(RDig, irnd(1,10) + 1, 1)
        NEXT Jr
    '   Obtain the random numbers
        RdNumb(Ir) =  VAL(LEFT(RdWholeDig,8))

    NEXT Ir

END SUB



'==================================================================
SUB Replace(BYREF gStr AS STRING,BYVAL wStr AS STRING, BYVAL repStr AS STRING)
 '  where     gStr = original string
 '                  wStr  =  wanted string to be replaced
 '                  repStr  =  replacement string
  DIM AS sys posWst,LenofwStr,LenofrepStr
  LenofwStr=LEN(wStr)
  IF LenofwStr=0 THEN
      EXIT SUB
  END IF


  LenofrepStr=LEN(repStr)
  if LenofrepStr= 0 THEN
      EXIT SUB
  END IF

  DO
    posWst=INSTR(posWst+1,gStr,wStr)
    IF posWst=0 THEN
      EXIT DO
    ELSE
      gStr=LEFT(gStr,posWst-1)+repStr+MID(gStr,posWst+LenofwStr)
    END IF
    posWst=LenofrepStr+posWst-1
  LOOP
END SUB


'=====================================================================
SUB ReplaceAny(BYREF gStr AS STRING,BYVAL wStr AS STRING, BYVAL repStr AS STRING)
 '  where     gStr = original string
 '                  wStr  =  wanted string to be replaced
 '                  repStr  =  replacement string
  DIM AS sys ac1,ac2,i,j,LenofwStr,LenofrepStr,LenofgivenStr
  DIM AS STRING chSt
  '
  LenofwStr=LEN(wStr)
  IF LenofwStr=0 THEN
       EXIT SUB
  END IF
  LenofrepStr=LEN(repStr)
  if LenofrepStr= 0 THEN
      EXIT SUB
  END IF


  LenofgivenStr=LEN(gStr)
  i=1
  DO
    IF i>LenofwStr THEN 
        EXIT DO
    END IF
    ac2=ASC(wStr,i)
    chSt=MID(repStr,i,1)
    j=1
    DO
      IF j>LenofgivenStr THEN 
            EXIT DO
      END IF
      ac1=ASC(gStr,j)
      IF ac1=ac2 THEN
           MID(gStr,j)=chSt
      END IF
      j+=1
    LOOP
    i+=1
  LOOP
END SUB    




'==================
' To clear the ClipBoard
Sub ClipB_Reset 
         OpenClipboard Null
          EmptyClipboard
          CloseClipboard
End Sub


function StringToHex(string s) as string
========================================
' https://www.oxygenbasic.org/forum/index.php?topic=1679.msg18190#msg18190
int le=len s
int i,j
string r=nuls le*2
indexbase 1
for i=1 to le
  j++
  mid r,j,hex(asc(s,i),2)
  j++
next
return r
end function
 


'==============================
' convert string to hex
FUNCTION Str2Hex(givenStr AS STRING) AS STRING
 
 LOCAL i  AS LONG
 Local  sHex AS STRING
 byte  bbt
 dim as byte pB at strptr(givenStr)

 ' need to start from element 1
  FOR i = 1 TO LEN(givenStr) 
    bbt = pB[i]
    sHex += HEX(bbt,2)
  NEXT i
  return sHex
END FUNCTION       




======================================== 
Function HexToString(string givSt) as string
int LengSt=len givSt
int i,j
string ResSt=Nuls LengSt\2
byte rb at strptr ResSt
indexbase 1
for i=1 to LengSt step 2
  j++
  rb[j]=val "0x" + MID(givSt,i,2)
next
return ResSt
end function


=======================================
Function StrReverse(string givenSt) as string
int LenSt=len givenSt
int j=LenSt
int i
string RevStt=nuls LenSt
byte StOrig at strptr givenSt
byte StRev at strptr RevStt
indexbase 1

for i=1 to LenSt
  StRev[j]=StOrig[i]
  j--
next
return RevStt
end function







===================================
'  Check whether folder or file exist
'  do not place in the last slash for the folder name
'  https://www.oxygenbasic.org/forum/index.php?topic=1668.msg18049#msg18049
function FileExists(char*wFil) as int
       WIN32_FIND_DATA wFildat
       sys hFil
        hFil=FindFirstFile wFil,wFildat
        if hFil>0 then
        '    File exists returns 1
            FindClose hFil
            return 1
        end if
end function


'===================================
FUNCTION ReadFileStr(gfnam AS STRING) AS STRING
   If  FileExists(gfnam) = 0 Then
'      exits if file does not exist
        Return ""
   End if 
  ' Reads in the entire file as a  string
'   for a given file name 
   string EFilStr 
        EFilStr = GetFile gfnam
   FUNCTION = EFilStr
END  FUNCTION



  ==============================
'  This function obtains the path name of
'  a given file wfnam
  Function GitPathNam( string wfnam ) as string
   if len(wfnam) = 0 then
      return ""
      exit function
  end if

   byte b at strptr wfnam
 ' iterates around the file name to get the position
'  of the last backslash
  sys islash
  do
    select b
    case 0 
              exit do
    case 92
            '   position of the last backslash
                islash=@b
    end select

    @b++
  end do
  return left wfnam,islash-strptr(wfnam)
  end function


'==========================
'  for copying a file from Source folder to
'  the destination folder
Function NcopyFil(string SrcFilepath, string DstFilepath) as bool
 string  srcFolder , dstFolder
'  Get the folder names
    srcFolder  = GitPathNam(SrcFilepath)
   dstFolder  =  GitPathNam( DstFilepath)


'  check if the folders exist or not
'  exit if it does not exist
      if  FileExists(SrcFolder)  = 0 then
           return False
           exit function
      end if
       if  FileExists(dstFolder)  = 0 then
             return False
           exit function
      end if

          if FileExists(SrcFilepath ) = 1 then
 '              destination folder and source file exist , we can copy the source file
'               and overwrites the existing file in destination folder
'               Need to set to False to get it overwritten
                  Function =  CopyFile(SrcFilepath,DstFilepath  , False)
           end if

end function







=================================
' Trims off all surrounding blanks
' http://www.jose.it-berater.org/smfforum/index.php?topic=5415.msg23548;topicseen#msg23548
' Reply #1 by Charles
Function Trim(string GivSt) as string
int i,j
int lst=len GivSt
if lst=0 then 
    return ""
end if

byte bbst at strptr(GivSt)
indexbase 1
for i=1 to lst
   if bbst[i]>32 then
      exit for
   end if
next

if i>lst then
    return ""
end if
for j=lst to 1 step -1
   if bbst[j]>32 then
     exit for
   end if
next
return mid(GivSt,i,j-i+1)
End Function


'===============================  
' for displaying the RGB colors 
Function RGB(sys wred,wgreen,wblue) as sys
  sys wcolor
  wcolor = wred
  wcolor = wcolor + wgreen*256
  wcolor = wcolor + wblue*65536
  Return wcolor
End Function 


'========================================
'  Redraws the transparent Label control to prevent
'  overlapping of  text due to frequent changes of labeling text
'  This is needed for labels that have transparent background
SUB  RedrawTransparentLabel(hmWin AS sys, hControl AS sys,  dispText AS STRING)
       RECT ControlRec 
'      gets the rect coordinates of the label
       GetClientRect(hControl, ControlRec)
       MapWindowPoints(hControl, hmWin, VARPTR(ControlRec), 2)
'     Redraw the control
      RedrawWindow(hmWin, ControlRec, NULL, RDW_ERASE OR RDW_INVALIDATE)
'     Display the text
      SetWindowText(hControl, dispText)
END SUB



'======================================== 
' draws with color gradient
SUB DrawGradient (BYVAL hBGDC AS sys)
   LOCAL rectFill AS RECT, rectClient AS RECT, fStep AS SINGLE
   local hBrush AS sys, lOnBand AS LONG
   GetClientRect WindowFromDC(hBGDC), rectClient
   fStep = rectClient.bottom / 75

   FOR lOnBand = 0 TO  30    ' 50 
      SetRect rectFill, 0, lOnBand * fStep, rectClient.right + 1, (lOnBand + 1) * fStep
      ' paint the background -- change the first 2 colors R and G
      ' to vary the color gradient

    Select case MainWindBGColor
      Case 1
      ' this gives a light yellow background
       hBrush = CreateSolidBrush(rgb(255, 255, 205 - lOnBand))
      Case 2
     ' this gives a cyan background
       hBrush = CreateSolidBrush(rgb(0, 248, 255 - lOnBand))

      Case 3
      ' this gives a light green background
        hBrush = CreateSolidBrush(rgb(155, 250, 147 - lOnBand))
      Case 4
    ' this gives a PaleTurquoise background
        hBrush = CreateSolidBrush(rgb(175,238,238 - lOnBand))

   Case 5
      ' this gives a MintCream background
        hBrush = CreateSolidBrush(rgb( 245,255,250 - lOnBand))
   Case 6
      ' this gives a OldLace background
        hBrush = CreateSolidBrush(rgb(253,245,230 - lOnBand))
   Case 7
      ' this gives a honeydew background
        hBrush = CreateSolidBrush(rgb(240,255,240 - lOnBand))
   Case 8
      ' this gives a lightcyan background
        hBrush = CreateSolidBrush(rgb(224,255,255 - lOnBand))

   Case 9
      ' this gives a PapayaWhip background
        hBrush = CreateSolidBrush(rgb(255,239,213- lOnBand))
   Case 10
      ' this gives a Cornsilk background
        hBrush = CreateSolidBrush(rgb( 255,248,220 - lOnBand))

      Case 11
      ' this gives a Azure background
        hBrush = CreateSolidBrush(rgb(240,255,255 - lOnBand))
      Case 12
      ' this gives a AliceBlue background
        hBrush = CreateSolidBrush(rgb(240,248,255 - lOnBand))

      Case 13
      ' this gives a Aquamarine  background
        hBrush = CreateSolidBrush(rgb( 127,255,212 - lOnBand))
     Case 14
      ' this gives a LightGoldenrodYellow background
        hBrush = CreateSolidBrush(rgb(   250,250,210 - lOnBand))
    Case 15
      ' this gives a Lavender background
        hBrush = CreateSolidBrush(rgb(230,230,250   - lOnBand))

    End Select

      Fillrect hBGDC, rectFill, hBrush
      DeleteObject hBrush
   NEXT

END SUB




'==============================================================================
'  Creates fonts 
'  For font weights use  FW_THIN   , FW_EXTRALIGHT ,  FW_LIGHT , FW_NORMAL ,  
' FW_MEDIUM  , FW_SEMIBOLD  , FW_BOLD   , FW_EXTRABOLD ,  FW_HEAVY      
Function O2ApiCreateFont(szFaceName As Zstring,Byval lPointSize As long, BYVAL lWeight  AS LONG) As sys
    Dim tlf As LOGFONT
    Dim Fhdc As sys
    Dim nNum As long
    Fhdc = GetDc(HWND_DESKTOP)
    nNum = GetDeviceCaps(Fhdc, LOGPIXELSY)
    tlf.lfHeight         = -MulDiv(lPointSize,nNum , 72)
    tlf.lfWidth          =  0
    tlf.lfEscapement     =  0
    tlf.lfOrientation    =  0
    tlf.lfWeight         = lWeight 
    tlf.lfItalic         =  0
    tlf.lfUnderline      =  0
    tlf.lfStrikeOut      =  0
    tlf.lfCharSet        =  ANSI_CHARSET
    tlf.lfOutPrecision   =  OUT_TT_PRECIS
    tlf.lfClipPrecision  =  CLIP_DEFAULT_PRECIS
    tlf.lfQuality        =  DEFAULT_QUALITY
    tlf.lfPitchAndFamily =  FF_DONTCARE
    tlf.lfFaceName       =  szFaceName
    ReleaseDC(HWND_DESKTOP, Fhdc)
Function = CreateFontIndirect(@tlf)
End Function


'===============================
' Return the value of a particular bit in a given variable 
Function Bit( sys gvr, bitnumber) as int
        Return ( gvr  >>  bitnumber ) and 1
End Function




